﻿Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic
   <HideModuleName()> _
   Public Module CollectionX

      Public Delegate Function GetChilds(Of T)(ByVal item As T) As IEnumerable

#Region "ICollection(mit und ohne T)"

      <Extension()> _
      Public Function ToArray(Of T)(ByVal subj As System.Collections.ICollection) As T()
         ReDim ToArray(subj.Count - 1)
         If subj.Count > 0 Then subj.CopyTo(ToArray, 0)
      End Function

#End Region 'ICollection(ohne T)

#Region "Array"
      ''' <summary>gibt den **typisierten** Enumerator des Arrays zurück</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Function GetEnumeratorX(Of T)(ByVal subj As T()) As IEnumerator(Of T)
         Return DirectCast(subj, IList(Of T)).GetEnumerator
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function Clone(Of T)(ByVal subj As T()) As T()
         ReDim Clone(subj.Length - 1)
         Array.Copy(subj, Clone, subj.Length)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Sub CopyX(ByVal Arr1 As Array, ByVal start1 As Integer, ByVal Arr2 As Array, ByVal start2 As Integer, ByVal Length As Integer)
         Array.Copy(Arr1, start1, Arr2, start2, Length)
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Sub CopyX(ByVal Arr1 As Array, ByVal Arr2 As Array, ByVal start2 As Integer, ByVal Length As Integer)
         Array.Copy(Arr1, 0, Arr2, start2, Length)
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Sub CopyX(ByVal Arr1 As Array, ByVal Arr2 As Array, ByVal start2 As Integer)
         Array.Copy(Arr1, 0, Arr2, start2, Arr1.Length)
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Function FindIndex(Of T)(ByVal Arr() As T, ByVal IsMatch As Predicate(Of T)) As Integer
         Return Array.FindIndex(Arr, IsMatch)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Find(Of T)(ByVal Arr() As T, ByVal IsMatch As Predicate(Of T)) As T
         Return Array.Find(Arr, IsMatch)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function IndexOf(Of T)(ByVal Arr() As T, ByVal Element As T) As Integer
         Return Array.IndexOf(Arr, Element)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Contains(Of T)(ByVal Arr() As T, ByVal Element As T) As Boolean
         Return DirectCast(Arr, IList(Of T)).Contains(Element)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function ConvertAll(Of TSrc, TDest)( _
              ByVal Arr() As TSrc, ByVal Converter As Converter(Of TSrc, TDest)) As TDest()
         Return Array.ConvertAll(Arr, Converter)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function ConvertAll(Of TSrc, TDest)( _
              ByVal Arr As IEnumerable(Of TSrc), ByVal Converter As Converter(Of TSrc, TDest)) As List(Of TDest)
         Return (From itm In Arr Select Converter(itm)).ToList
      End Function
      <Obsolete("Try ReDim preserve array(array.CloseUp(predicate)-1)")> _
      <Extension()> _
      Public Sub KeepOnly(Of T)(ByRef subj() As T, ByVal predicate As Predicate(Of T))
         Dim i = subj.CloseUp(predicate)
         Dim newArr(i - 1) As T
         Array.Copy(subj, newArr, i)
         subj = newArr
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Sub Sort(Of T)(ByVal subj() As T)
         Array.Sort(subj)
      End Sub

#End Region 'Array

#Region "List(Of T)"

      <Extension()> _
      Public Sub SortX(Of T)(ByVal Subj As List(Of T), ByVal ParamArray getters() As Func(Of T, IComparable))
         Dim comparison As Comparison(Of T)
         Select Case getters.Length
            Case 0 : Throw Subj.Exception("cannot SortX with no getter defined")
            Case 1
               Dim gt = getters(0)
               comparison = Function(x As T, y As T) gt(x).CompareTo(gt(y))
            Case Else
               comparison = _
                  Function(x As T, y As T)
                     For Each gt In getters
                        Dim cmp = gt(x).CompareTo(gt(y))
                        If cmp <> 0 Then Return cmp
                     Next
                     Return 0
                  End Function
         End Select
         Subj.Sort(comparison)
      End Sub

      ''' <summary>lineare Suche in sortierter Liste (aufwärts oder abwärts), startend bei index. Schneller als BinarySearch, um bei nur teilweise assoziierten Listen die matchenden Elemente aufzufinden. Bei match ist der günstigste nächste start-index der match-index + 1. Bei nicht-match unverändert lassen</summary>
      <Extension()> _
      Public Function TryFindLinearInSortedList(Of T, TKey As IComparable)(ByVal lst As IList(Of T), ByVal key As TKey, ByVal selector As Func(Of T, TKey), ByRef index As Integer) As Boolean
         Dim i = index
         If i >= lst.Count Then i = lst.Count - 1
         If i < 0 Then Return False
         Dim direction = key.CompareTo(selector(lst(i)))
         Select Case direction
            Case -1
               For i = index - 1 To 0 Step -1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then index = i : Return True
                     Return False
                  End If
               Next
            Case 0 : Return True
            Case Else
               For i = index + 1 To lst.Count - 1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then index = i : Return True
                     Return False
                  End If
               Next
         End Select
      End Function
      <Extension()> _
      Public Function FindLinearInSortedList(Of T, TKey As IComparable)(ByVal lst As IList(Of T), ByVal key As TKey, ByVal selector As Func(Of T, TKey), ByVal start As Integer) As Integer
         If start < 0 Then Return -1
         Dim i = start
         Dim direction = key.CompareTo(selector(lst(i)))
         Select Case direction
            Case -1
               For i = start - 1 To 0 Step -1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then Return i
                     Exit For
                  End If
               Next
               Return Not (i + 1)
            Case 0 : Return i
            Case Else
               For i = start + 1 To lst.Count - 1
                  Dim cmp = key.CompareTo(selector(lst(i)))
                  If direction <> cmp Then
                     If cmp = 0 Then Return i
                     Exit For
                  End If
               Next
               Return Not i
         End Select
      End Function

      <Extension()> _
      Public Sub KeepOnly(Of T)(ByRef subj As List(Of T), ByVal predicate As Predicate(Of T))
         Dim i = subj.CloseUp(predicate)
         subj.RemoveRange(i, subj.Count - i)
      End Sub

      <Extension()> _
      Public Sub InsertOrAdd(Of T)( _
            ByVal subj As List(Of T), ByVal item As T, ByVal predicate As Predicate(Of T))
         subj.InsertOrAdd(subj.FindIndex(predicate), item)
      End Sub

      <Extension()> _
      Public Sub InsertOrAt0(Of T)( _
            ByVal subj As List(Of T), ByVal item As T, ByVal predicate As Predicate(Of T))
         subj.InsertOrAt0(subj.FindIndex(predicate), item)
      End Sub

      ''' <summary>returnt die Einfügeposition des items in die asc-sortierte Liste </summary>
      <Extension()> _
      Public Function InsertPosition(Of T As IComparable)( _
            ByVal subj As List(Of T), ByVal item As T) As Integer
         Dim i = subj.BinarySearch(item)
         Return If(i < 0, Not i, i)
      End Function

#End Region 'List(Of T)

#Region "Dictionary(Of T, T2)"

      <Extension()> _
      Public Function GetOrCreate(Of Tkey, Tvalue As New)( _
            ByVal subj As Dictionary(Of Tkey, Tvalue), ByVal key As Tkey) As Tvalue
         Dim ret As Tvalue
         If Not subj.TryGetValue(key, ret) Then
            ret = New Tvalue
            subj.Add(key, ret)
         End If
         Return ret
      End Function

#End Region 'Dictionary(Of T, T2)

#Region "IList / IList(Of T)"

      <Extension()> _
      Public Function FirstDifference(Of T)(ByVal lists() As IList(Of T), ByVal selector As Func(Of T, Object)) As Integer
         Dim commonLength = Aggregate l In From lst In lists Select lst.Count Into Min()
         Dim ubound = lists.Count - 1
         For retVal = 0 To commonLength - 1
            Dim cmp = selector(lists(0)(retVal))
            For ii = 1 To ubound
               If Not selector(lists(ii)(retVal)).Equals(cmp) Then Return retVal
            Next
         Next
         Return commonLength
      End Function
      <Extension()> _
      Public Function FirstDifference(ByVal lists() As IList) As Integer
         Dim commonLength = Aggregate l In From lst In lists Select lst.Count Into Min()
         Dim ubound = lists.Count - 1
         For retVal = 0 To commonLength - 1
            Dim cmp = lists(0)(retVal)
            For ii = 1 To ubound
               If Not lists(ii)(retVal).Equals(cmp) Then Return retVal
            Next
         Next
         Return commonLength
      End Function

      <Extension()> _
      Public Sub InsertOrAdd(Of T)(ByVal subj As IList(Of T), ByVal index As Integer, ByVal item As T)
         subj.Insert(If(index < 0, subj.Count, index), item)
      End Sub

      <Extension()> _
      Public Sub InsertOrAt0(Of T)(ByVal subj As IList(Of T), ByVal index As Integer, ByVal item As T)
         subj.Insert(If(index < 0, 0, index), item)
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Function Clone(Of T As {IList, New})(ByVal subj As T) As T
         Clone = New T
         For Each itm In subj
            Clone.Add(itm)
         Next
      End Function

      ''' <summary>Bsp: vorletztes Element: list.Peek(-1)</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Function Peek(Of T)(ByVal subj As IList(Of T), Optional ByVal index As Integer = 0) As T
         Return subj(index + subj.Count - 1)
      End Function
      ''' <summary>Bsp: setze vorletztes Element: list.Poke(-1, "huhu")</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Sub Poke(Of T)(ByVal subj As IList(Of T), ByVal value As T, Optional ByVal index As Integer = 0)
         subj(index + subj.Count - 1) = value
      End Sub

      <Obsolete("use IList(Of T).Peek-Extension")> _
      <Extension()> _
      Public Function Last(Of T)(ByVal subj As IList(Of T), ByVal index As Integer) As T
         Return subj(index + subj.Count - 1)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function Pop(Of T)(ByVal Subj As IList(Of T)) As T
         Dim i = Subj.Count - 1
         Pop = Subj(i)
         Subj.RemoveAt(i)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function PopAndPeek(Of T)(ByVal Subj As IList(Of T)) As T
         Dim i = Subj.Count - 1
         Subj.RemoveAt(i)
         Return Subj(i - 1)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Sub Swap(ByVal Subj As IList, ByVal I1 As Integer, ByVal I2 As Integer)
         Dim Tmp = Subj(I1)
         Subj(I1) = Subj(I2)
         Subj(I2) = Tmp
      End Sub

      ''' <summary>Refill oldValues with minimum occurances of CollectionChanged-Event</summary>
      ''' <param name="selectors">each selector extracts a significant Property from Item, to decide, whether two items are equal. multiple selectors consider multiple Properties</param>
      <Extension()> _
      Public Sub ReFillBy(Of T)(ByVal oldValues As IList(Of T), ByVal newValues As IEnumerable(Of T), ByVal ParamArray selectors() As Func(Of T, Object))
         Using ernt = newValues.GetEnumerator
            For i = 0 To oldValues.Count - 1
               If Not ernt.MoveNext Then
                  For ii = oldValues.Count - 1 To i Step -1
                     oldValues.RemoveAt(ii)
                  Next
                  Return
               End If
               Dim itm0 = oldValues(i)
               Dim itm1 = ernt.Current
               If Not (Object.Equals(itm0, itm1) OrElse (selectors.Count > 0 AndAlso selectors.All(Function(sel) Object.Equals(sel(itm0), sel(itm1))))) Then oldValues(i) = itm1
            Next
            While ernt.MoveNext
               oldValues.Add(ernt.Current)
            End While
         End Using
      End Sub
      <Extension()> _
      Public Sub AddRangeAt(Of T)(ByVal Subj As IList(Of T), ByVal range As IEnumerable(Of T), Optional ByVal start As Integer = Integer.MaxValue)
         Using ernt = range.GetEnumerator
            For i = start To Subj.Count - 1
               If Not ernt.MoveNext Then
                  For ii = Subj.Count - 1 To i Step -1 : Subj.RemoveAt(ii) : Next
                  Return
               End If
               Subj(i) = ernt.Current
            Next
            While ernt.MoveNext : Subj.Add(ernt.Current) : End While
         End Using
      End Sub

      <Extension()> _
      Public Sub RemoveRangeX(ByVal Subj As IList, ByVal start As Integer, Optional ByVal count As Integer = Integer.MaxValue)
         count = Math.Min(count, Subj.Count - start)
         For i = start + count To Subj.Count - 1
            Subj(i - count) = Subj(i)
         Next
         For i = Subj.Count - 1 To Subj.Count - count Step -1
            Subj.RemoveAt(i)
         Next
      End Sub


#End Region 'IList

#Region "Enumerable"

      <Extension()> _
      Public Function ExceptAt(Of T)(ByVal subj As IEnumerable(Of T), ByVal index As Integer) As List(Of T)
         ExceptAt = New List(Of T)
         With subj.GetEnumerator
            If index >= 0 Then
               For i = 0 To index - 1
                  If Not .MoveNext Then Exit Function
                  ExceptAt.Add(.Current)
               Next
               If Not .MoveNext Then Exit Function
            End If
            While .MoveNext : ExceptAt.Add(.Current) : End While
         End With
      End Function

      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Yield(Of T)(ByVal subj As IEnumerator(Of T)) As T
         subj.MoveNext()
         Return subj.Current
      End Function
      ''' <summary>Exception on empty collection</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Function YieldCyclic(Of T)(ByVal subj As IEnumerator(Of T)) As T
         With subj
            If .MoveNext Then Return .Current
            .Reset() : .MoveNext() : Return .Current
         End With
      End Function
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Yield(ByVal subj As IEnumerator) As Object
         subj.MoveNext()
         Return subj.Current
      End Function

      <Extension()> _
      Public Function EachEquals(Of T As IEquatable(Of T))( _
            ByVal subj As IEnumerable(Of T), ByVal other As IEnumerable(Of T)) As Boolean
         Using e1 = subj.GetEnumerator, e2 = other.GetEnumerator
            Do
               If e1.MoveNext Then
                  If Not e2.MoveNext Then Return False 'e2 kürzer als e1
                  If Not e1.Current.Equals(e2.Current) Then Return False
                  Continue Do
               Else
                  Return Not e2.MoveNext 'returnt false, wenn e2 länger als e1
               End If
            Loop
         End Using
      End Function

      Public Structure MinMax(Of T, T2 As IComparable)
         Public Min, Max As T
         Public MinVal, MaxVal As T2
         Private _Selector As Func(Of T, T2)
         Public ReadOnly HasValue As Boolean
         Public Sub New(ByVal first As T, ByVal selector As Func(Of T, T2))
            _Selector = selector
            Me.Min = first : Me.Max = first
            MinVal = _Selector(first) : MaxVal = MinVal
            HasValue = True
         End Sub
         Public Sub Check(ByVal itm As T)
            Dim val = _Selector(itm)
            If val.CompareTo(MinVal) < 0 Then
               Min = itm
               MinVal = val
            ElseIf val.CompareTo(MaxVal) > 0 Then
               Max = itm
               MaxVal = val
            End If
         End Sub
      End Structure

      'Public Structure MinMax(Of T)
      '   Public Min, Max As T
      '   Private MinVal, MaxVal As IComparable
      '   Private _Selector As Func(Of T, IComparable)
      '   Public HasValue As Boolean
      '   Public Sub New(ByVal selector As Func(Of T, IComparable))
      '      _Selector = selector
      '   End Sub
      '   Public Sub New(ByVal first As T, ByVal selector As Func(Of T, IComparable))
      '      MyClass.New(selector)
      '      Check(first)
      '   End Sub
      '   Public Sub New(ByVal first As T)
      '      MyClass.New(first, Function(itm) DirectCast(itm, IComparable))
      '   End Sub
      '   Public Sub Check(ByVal itm As T)
      '      If HasValue Then
      '         CheckNext(itm)
      '      Else
      '         Me.Min = itm : Me.Max = itm
      '         MinVal = _Selector(itm) : MaxVal = MinVal
      '         HasValue = True
      '      End If
      '   End Sub
      '   Public Sub CheckNext(ByVal itm As T)
      '      Dim val = _Selector(itm)
      '      If val.CompareTo(MinVal) < 0 Then
      '         Min = itm
      '         MinVal = val
      '      ElseIf val.CompareTo(MaxVal) > 0 Then
      '         Max = itm
      '         MaxVal = val
      '      End If
      '   End Sub
      'End Structure

      '<Extension()> _
      'Public Function Extremum(Of T, T2 As IComparable)( _
      '      ByVal Subj As IEnumerable(Of T), ByVal Converter As Func(Of T, T2)) As MinMax(Of T, T2)
      '   With Subj.GetEnumerator
      '      If Not .MoveNext Then Exit Function 'returnt leeres MinMax
      '      Dim MinMax = New MinMax(Of T)(.Current)
      '      Dim Values = New MinMax(Of T2)(Converter(.Current))
      '      While .MoveNext
      '         Dim Val = Converter(.Current)
      '         If Val.CompareTo(Values.Min) < 0 Then
      '            MinMax.Min = .Current
      '            Values.Min = Val
      '         ElseIf Val.CompareTo(Values.Max) > 0 Then
      '            MinMax.Max = .Current
      '            Values.Max = Val
      '         End If
      '      End While
      '      .Dispose()
      '      Return MinMax
      '   End With
      'End Function

      <Extension()> _
      Public Function Extremum(Of T, T2 As IComparable)( _
            ByVal Subj As IEnumerable(Of T), ByVal selector As Func(Of T, T2)) As MinMax(Of T, T2)
         With Subj.GetEnumerator
            If Not .MoveNext Then .Dispose() : Return Nothing
            Extremum = New MinMax(Of T, T2)(.Current, selector)
            While .MoveNext : Extremum.Check(.Current) : End While
            .Dispose()
         End With
      End Function

      <Extension()> _
      Public Function AllChilds(Of T)( _
            ByVal GetChilds As Func(Of T, IEnumerable), _
            ByVal Roots As IEnumerable) As IEnumerable(Of T)
         Dim Enumerate As Func(Of IEnumerable(Of T), IEnumerable(Of T)) = Nothing
         Enumerate = Function(enmbl) enmbl.Concat(enmbl.SelectMany(Function(nd) Enumerate(GetChilds(nd).Cast(Of T))))
         Return Enumerate(Roots.Cast(Of T))
      End Function

      <Extension()> _
      Public Function All(Of T)( _
            ByVal GetChilds As Func(Of T, IEnumerable), ByVal Root As T) As IEnumerable(Of T)
         'Root wird in die Enumeration hineingenommen, indem ein es enthaltendes IEnumerable(Of T) 
         'geschaffen wird, dessen Kinder ( = nur Root ) rekursiv enumeriert werden
         Return GetChilds.AllChilds(New T() {Root})
      End Function

      <Extension()> _
      Public Function AllAsList(Of T)(ByVal getChilds As GetChilds(Of T), ByVal Roots As IEnumerable) As List(Of T)
         Dim ret As New List(Of T)
         For Each child As T In Roots : ret.Add(child) : Next
         Dim i As Integer = 0
         While i < ret.Count
            For Each child As T In getChilds(ret(i)) : ret.Add(child) : Next
            i += 1
         End While
         Return ret
      End Function

      <Extension()> _
      Public Function AllAsList(Of T)(ByVal getChilds As GetChilds(Of T), ByVal Root As T) As List(Of T)
         Return getChilds.AllAsList(New T() {Root})
      End Function

      <Extension()> _
      Public Function DisposeAll(Of T As IDisposable)(ByVal Subj As IList(Of T)) As IList(Of T)
         For Each itm As T In Subj
            If itm IsNot Nothing Then itm.Dispose()
         Next
         If Not Subj.IsReadOnly Then Subj.Clear()
         Return Subj
      End Function

      <Extension()> _
      Public Sub DisposeAll(Of T As IDisposable)(ByVal Subj As IEnumerable(Of T))
         For Each itm As T In Subj
            If itm IsNot Nothing Then itm.Dispose()
         Next
      End Sub

      <Extension()> _
      Public Function FindIndex(Of T)(ByVal Subj As IList(Of T), ByVal predicate As Func(Of T, Boolean), Optional ByVal start As Integer = 0) As Integer
         For FindIndex = start To Subj.Count - 1
            If predicate(Subj(FindIndex)) Then Exit Function
         Next
         Return -1
      End Function

      <Extension()> _
      Public Function FindIndex(Of T)(ByVal Subj As IList, ByVal predicate As Func(Of T, Boolean), Optional ByVal start As Integer = 0) As Integer
         For FindIndex = start To Subj.Count - 1
            If predicate(DirectCast(Subj(FindIndex), T)) Then Exit Function
         Next
         Return -1
      End Function

      <Extension()> _
      Public Sub ForEach(Of T)(ByVal Subj As IEnumerable, ByVal Action As Action(Of T))
         For Each itm As T In Subj
            Action(itm)
         Next
      End Sub

      <Extension()> _
      Public Sub ForEach(Of T)(ByVal Subj As IEnumerable(Of T), ByVal Action As Action(Of T))
         For Each itm In Subj
            Action(itm)
         Next
      End Sub

      <Extension()> _
      Public Function Except(Of T)(ByVal Subj As IEnumerable(Of T), ByVal item As T) As IEnumerable(Of T)
         Return Subj.Except(New T() {item})
      End Function

      <Extension()> _
      Public Function ToList(Of T)(ByVal Subj As IEnumerable(Of T), ByVal other As IEnumerable(Of T), ByVal ParamArray more() As IEnumerable(Of T)) As List(Of T)
         Dim src(1 + more.Length) As IEnumerable(Of T)
         src(0) = Subj
         src(1) = other
         more.CopyX(0, src, 2, more.Length)
         Return src.SelectMany(Function(answers) answers).ToList
      End Function

#End Region 'Enumerable

#Region "Helpers"
      ''' <summary>überschreibt alle matchende items mit den folgenden. returnt den index, ab dem der rest gelöscht werden kann</summary>
      <Extension()> _
      Private Function CloseUp(Of T)(ByVal subj As IList(Of T), ByVal predicate As Predicate(Of T)) As Integer
         Dim i As Integer
         For i = 0 To subj.Count - 1
            If Not predicate(subj(i)) Then Exit For
         Next
         For ii As Integer = i + 1 To subj.Count - 1
            If predicate(subj(ii)) Then
               subj(i) = subj(ii)
               i += 1
            End If
         Next
         Return i
      End Function

#End Region 'Helpers

   End Module

End Namespace
