﻿Namespace System

   ''' <summary> generische Exception mit genauen Daten über das fehler-werfende Objekt </summary>
   Public Class Exception(Of T) : Inherits System.Exception

      Private Shared Function TypeInfo() As String
         Dim tp = GetType(T)
         With tp.Name
            Dim i = .IndexOf("`"c)
            If i < 0 Then Return tp.Name
            Return String.Concat(.Substring(0, i), "<", String.Join(",", Array.ConvertAll(tp.GetGenericArguments, Function(TParam) TParam.Name)), ">")
         End With
      End Function

      Public Sub New(ByVal sender As T, ByVal innerException As Exception, ByVal message As String)
         MyBase.New(String.Concat( _
            TypeInfo, "-Exception", _
            If(String.IsNullOrEmpty(message), "", ": " & Environment.NewLine & message)), innerException)
#If DEBUG Then
         'If System.Windows.Forms.Application.OpenForms.Count = 0 Then Stop
#End If
      End Sub

   End Class

End Namespace
