﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.ComponentModel

Namespace System.Threading
   Public Module ThreadingX
      Public ReadOnly SyncContext As SynchronizationContext = SynchronizationContext.Current
      Public ReadOnly SyncThreadID As Integer = Thread.CurrentThread.ManagedThreadId
      Public Sub InitSync()
         If SyncThreadID <> Thread.CurrentThread.ManagedThreadId Then Throw New Exception("First call must be in Gui-Thread")
      End Sub
      <Extension()> _
      Public Sub Runasync(Of T1, T2, T3)( _
            ByVal action As Action(Of T1, T2, T3), ByVal arg1 As T1, ByVal arg2 As T2, ByVal arg3 As T3)
         ' aufruf von action.EndInvoke() gewährleisten, indem er als Callback-argument mitgegeben wird
         action.BeginInvoke(arg1, arg2, arg3, AddressOf action.EndInvoke, Nothing)
      End Sub
      <Extension()> _
      Public Sub Runasync(Of T1, T2)( _
            ByVal action As Action(Of T1, T2), ByVal arg1 As T1, ByVal arg2 As T2)
         action.BeginInvoke(arg1, arg2, AddressOf action.EndInvoke, Nothing)
      End Sub
      <Extension()> _
      Public Sub Runasync(Of T1)(ByVal action As Action(Of T1), ByVal arg1 As T1)
         action.BeginInvoke(arg1, AddressOf action.EndInvoke, Nothing)
      End Sub
      <Extension()> _
      Public Sub Runasync(ByVal action As Action)
         action.BeginInvoke(AddressOf action.EndInvoke, Nothing)
      End Sub

      <Extension()> _
      Public Sub RunGui(Of T1, T2, T3)( _
            ByVal action As Action(Of T1, T2, T3), ByVal arg1 As T1, ByVal arg2 As T2, ByVal arg3 As T3)
         If SyncThreadID = Thread.CurrentThread.ManagedThreadId Then
            action(arg1, arg2, arg3)
         Else
            Dim caller As SendOrPostCallback = _
               Sub(state)
                  With DirectCast(state, Tuple(Of Action(Of T1, T2, T3), T1, T2, T3))
                     .Item1.Invoke(.Item2, .Item3, .Item4)
                  End With
               End Sub
            SyncContext.Post(caller, Tuple.Create(action, arg1, arg2, arg3))
         End If
      End Sub
      <Extension()> _
      Public Sub RunGui(Of T1, T2)( _
            ByVal action As Action(Of T1, T2), ByVal arg1 As T1, ByVal arg2 As T2)
         If SyncThreadID = Thread.CurrentThread.ManagedThreadId Then
            action(arg1, arg2)
         Else
            Dim caller As SendOrPostCallback = _
               Sub(state)
                  With DirectCast(state, Tuple(Of Action(Of T1, T2), T1, T2))
                     .Item1.Invoke(.Item2, .Item3)
                  End With
               End Sub
            SyncContext.Post(caller, Tuple.Create(action, arg1, arg2))
         End If
      End Sub
      <Extension()> _
      Public Sub RunGui(Of T1)(     ByVal action As Action(Of T1), ByVal arg1 As T1)
         If SyncThreadID = Thread.CurrentThread.ManagedThreadId Then
            action(arg1)
         Else
            Dim caller As SendOrPostCallback = _
               Sub(state)
                  With DirectCast(state, Tuple(Of Action(Of T1), T1))
                     .Item1.Invoke(.Item2)
                  End With
               End Sub
            SyncContext.Post(caller, Tuple.Create(action, arg1))
         End If
      End Sub
      <Extension()> _
      Public Sub RunGui( ByVal action As Action)
         If SyncThreadID = Thread.CurrentThread.ManagedThreadId Then
            action.Invoke()
         Else
            SyncContext.Post(Sub(state) DirectCast(state, Action)(), action)
         End If
      End Sub
   End Module
End Namespace
