﻿Namespace System.Runtime.CompilerServices

   Public MustInherit Class WeakAttachBase2(Of TKey As Class, Tself As {WeakAttachBase2(Of TKey, Tself), New})

      Private Shared ReadOnly _IListFields As New ConditionalWeakTable(Of TKey, Tself)

      Private Shared creater As ConditionalWeakTable(Of TKey, Tself).CreateValueCallback = _
         Function(k) New Tself With {._Key = k}

      Protected _Key As TKey

      Public Shared Function GetAttached(ByVal key As TKey) As Tself
         Return _IListFields.GetValue(key, creater)
      End Function

   End Class


   Public MustInherit Class WeakAttachBase(Of TKey As Class, Tself As {WeakAttachBase(Of TKey, Tself), New})
      Protected Shared ReadOnly _IListFields As New ConditionalWeakTable(Of Object, Tself)
      Protected Shared creater As ConditionalWeakTable(Of Object, Tself).CreateValueCallback = Function(k) New Tself

      Public Shared Function [Get](ByVal key As Object) As Tself
         Return _IListFields.GetValue(key, creater)
      End Function
      <Obsolete("better use WeakAttachBase.Get() - Method")> _
      Public Shared Function GetAttached(ByVal key As Object) As Tself
         Return _IListFields.GetValue(key, creater)
      End Function
      Public Shared Function TryGet(ByVal key As Object, ByRef value As Tself) As Boolean
         Return _IListFields.TryGetValue(key, value)
      End Function
      Public Shared Function Exists(ByVal key As Object) As Boolean
         Dim value As Tself = Nothing
         Return _IListFields.TryGetValue(key, value)
      End Function
      Public Shared Function Remove(ByVal key As Object) As Boolean
         Return _IListFields.Remove(key)
      End Function
   End Class

   'Public MustInherit Class WeakAttachBase(Of TKey As Class, Tself As {WeakAttachBase(Of TKey, Tself), New})
   '     Private Shared ReadOnly _IListFields As New ConditionalWeakTable(Of Object, Tself)
   '     Private Shared creater As ConditionalWeakTable(Of Object, Tself).CreateValueCallback = _
   '      Function(k) New Tself With {._Key = (DirectCast(k, TKey))}
   '     Protected _Key As TKey
   '     Public Shared Function GetAttached(ByVal key As Object) As Tself
   '      Return _IListFields.GetValue(key, creater)
   '   End Function
   '  End Class

End Namespace
