﻿Imports System.Globalization
Imports System.Data

Namespace System.Windows.Controls

   Public Class DelegateConverter : Inherits DependencyObject : Implements IValueConverter

      Public Shared ReadOnly ConversionProperty As DependencyProperty = New DepProp(Echo(Of Object).Instance, GetType(DelegateConverter), "Conversion")
      Public Property Conversion() As Func(Of Object, Object)
         <DebuggerStepThrough()> _
         Get
            Return DirectCast(GetValue(ConversionProperty), Func(Of Object, Object))
         End Get
         <DebuggerStepThrough()> _
         Set(ByVal NewValue As Func(Of Object, Object))
            SetValue(ConversionProperty, NewValue)
         End Set
      End Property

      Public Shared ReadOnly BackConversionProperty As DependencyProperty = New DepProp(Echo(Of Object).Instance, GetType(DelegateConverter), "BackConversion")
      Public Property BackConversion() As Func(Of Object, Object)
         <DebuggerStepThrough()> _
         Get
            Return DirectCast(GetValue(BackConversionProperty), Func(Of Object, Object))
         End Get
         <DebuggerStepThrough()> _
         Set(ByVal NewValue As Func(Of Object, Object))
            SetValue(BackConversionProperty, NewValue)
         End Set
      End Property

      <DebuggerStepThrough()> _
      Public Overridable Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As CultureInfo) As Object Implements IValueConverter.Convert
         Return Conversion(value)
      End Function

      <DebuggerStepThrough()> _
      Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As CultureInfo) As Object Implements IValueConverter.ConvertBack
         Return BackConversion(value)
      End Function
   End Class

   Public Class DebugConverter : Inherits DelegateConverter
      Public Overrides Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As Globalization.CultureInfo) As Object
         Return MyBase.Convert(value, targetType, parameter, culture)
      End Function
   End Class

End Namespace
