﻿Imports System.ComponentModel
Imports System.Globalization

Namespace System.Windows.Controls
   ''' <summary>
   ''' &lt;Image Height="{Binding  ElementName=myFontSizeRatio, Path=[2.5]}"  /&gt; (Image.Height = 2.5 * FontSize)
   ''' </summary>
   <TypeConverter(GetType(FontSizeRatioConverter))> _
   Public Class FontSizeRatio : Inherits UIElement

      Private _ParentControl As Control = Nothing

      Default Public ReadOnly Property Item(ByVal factor As Double) As Double
         Get
            If _ParentControl.Null Then
               _ParentControl = Me.FindParent(Of Control)()
               If _ParentControl.Null Then Return 11 * factor
            End If
            Return _ParentControl.FontSize * factor
         End Get
      End Property

   End Class

   Public Class FontSizeRatioConverter : Inherits TypeConverter

      Public Overrides Function CanConvertFrom(ByVal context As ITypeDescriptorContext, ByVal sourceType As Type) As Boolean
         Return False
      End Function
      Public Overrides Function CanConvertTo(ByVal context As ITypeDescriptorContext, ByVal destinationType As Type) As Boolean
         Return destinationType Is GetType(Double) OrElse destinationType Is GetType(String)
      End Function
      Public Overrides Function ConvertFrom(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object) As Object
         Throw New InvalidOperationException
      End Function
      Public Overrides Function ConvertTo(ByVal context As ITypeDescriptorContext, ByVal culture As CultureInfo, ByVal value As Object, ByVal destinationType As Type) As Object
         Dim size = DirectCast(value, FontSizeRatio).Item(1)
         If destinationType Is GetType(String) Then Return size.ToString
         Return size
      End Function

   End Class

End Namespace
