Imports System
Imports System.Diagnostics
Namespace System
   Public Class NotifyEventArgs(Of T) : Inherits EventArgs
      Public ReadOnly Value As T
      Public Sub New(ByVal Value As T)
         MyBase.New()
         Me.Value = Value
      End Sub
   End Class 'NotifyEventArgs(Of T)

   Public Delegate Sub EventHandlerEx(Of T0, T1 As EventArgs)(ByVal Sender As T0, ByVal e As T1)

   Public Delegate Sub EventHandlerEx(Of T0)(ByVal Sender As T0)

   Public Module modHelpers

      Public DebugDummi As Object

      <DebuggerStepThrough()> _
      Public Sub Nop()
      End Sub

      Public Function EnumGetName(Of T As Structure)(ByVal Value As T) As String
         Return [Enum].GetName(GetType(T), Value)
      End Function

      Public Function DisposeManaged(Of T As IDisposable)( _
            ByVal disposing As Boolean, _
            ByRef First As T, _
            ByVal ParamArray Disposables As IDisposable()) As Boolean
         If Not disposing Then Return False
         If First Is Nothing Then Return False
         First.Dispose()
         First = Nothing
         For Each D As IDisposable In Disposables
            D.Dispose()
         Next
         Return True
      End Function

      Private _DbgID As Integer

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(ByVal Args As IEnumerable)
         Dim Args2 As New List(Of Object)
         Args2.Add(_DbgID)
         _DbgID = (_DbgID + 1) Mod 10
         For Each arg In Args
            Args2.Add(" ")
            Args2.Add(arg)
         Next
         Console.WriteLine(String.Concat(Args2))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(ByVal Args As IList(Of Object))
         Dim Args2(Args.Count * 2) As Object
         Args2(0) = _DbgID & " "
         _DbgID = (_DbgID + 1) Mod 10
         For i As Integer = 0 To Args.Count - 1
            Args2(i * 2 + 1) = If(Args(i), "##-Null-##")
            Args2(i * 2 + 2) = " "
         Next
         Console.WriteLine(String.Concat(Args2))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(ByVal ParamArray Args As Object())
         Dbg(DirectCast(Args, IList(Of Object)))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(ByVal s As String)
         Console.WriteLine(String.Concat(_DbgID, " ", s))
         _DbgID = (_DbgID + 1) Mod 10
      End Sub
      Private _Sw As New Stopwatch
      ''' <summary>initiate by calling without Args</summary>
      Public Sub DbgTime(ByVal ParamArray Args As Object())
         If Args.Length = 0 Then _Sw.Restart() : Return
         Dim Args2(Args.Count * 2) As Object
         Args2(0) = String.Format("{0,6} ", CInt(_Sw.ElapsedMilliseconds))
         For i As Integer = 0 To Args.Count - 1
            Args2(i * 2 + 1) = If(Args(i), "##-Null-##")
            Args2(i * 2 + 2) = " "
         Next
         Console.WriteLine(String.Concat(Args2))
      End Sub

      Public Function Msg(ByVal msg1 As String, ByVal ParamArray msgs() As Object) As Microsoft.VisualBasic.MsgBoxResult
         Return Microsoft.VisualBasic.MsgBox(String.Concat(msg1, String.Concat(msgs)))
      End Function

   End Module


End Namespace
